#import "GLContextInfoPatch.h"
#import "OpenGL/gl.h"
#import "OpenGL/OpenGL.h"

@implementation GLContextInfoPatch : QCPatch

+ (int)executionMode
{
	return 0;
}
+ (BOOL)allowsSubpatches
{
	return NO;
}
+ (int)timeMode
{
	return 1;
}

- (id)attributes
{
	NSMutableDictionary *at=[[super attributes] mutableCopy];
	[at setObject:@"Kineme GL Context Info" forKey:@"name"];
	return at;
}


- (void)enable:(QCOpenGLContext *)context
{
	CGLSetCurrentContext([context CGLContextObj]);

	GLint v;

	glGetIntegerv(GL_RED_BITS,&v);
	[outputBitsRed setIndexValue:v];
	glGetIntegerv(GL_GREEN_BITS,&v);
	[outputBitsGreen setIndexValue:v];
	glGetIntegerv(GL_BLUE_BITS,&v);
	[outputBitsBlue setIndexValue:v];
	glGetIntegerv(GL_ALPHA_BITS,&v);
	[outputBitsAlpha setIndexValue:v];

	glGetIntegerv(GL_ACCUM_RED_BITS,&v);
	[outputBitsAccumRed setIndexValue:v];
	glGetIntegerv(GL_ACCUM_GREEN_BITS,&v);
	[outputBitsAccumGreen setIndexValue:v];
	glGetIntegerv(GL_ACCUM_BLUE_BITS,&v);
	[outputBitsAccumBlue setIndexValue:v];
	glGetIntegerv(GL_ACCUM_ALPHA_BITS,&v);
	[outputBitsAccumAlpha setIndexValue:v];

	glGetIntegerv(GL_DEPTH_BITS,&v);
	[outputBitsDepth setIndexValue:v];

	glGetIntegerv(GL_STENCIL_BITS,&v);
	[outputBitsStencil setIndexValue:v];
}
@end
